MPLS Network Action for Entropy
Tony Li
Juniper Networks
tony.li@tony.li
John Drake
je_drake@yahoo.com
28 August 2024
MPLS Working Group
Load balancing is a powerful tool for engineering traffic across a network and has been successfully used in MPLS as described in RFC 6790, "The Use of Entropy Labels in MPLS Forwarding". With the emergence of MPLS Network Actions (MNA), there is signficant benefit in being able to invoke the same load balancing capabilities within the more general MNA infrastructure.
This document describes a network action for entropy to be used in conjunction with "MPLS Network Action (MNA) Sub-Stack Solution".
Introduction
Load balancing is a powerful tool for engineering traffic across a network. The use of entropy labels within MPLS was first described in [RFC6790] and [RFC6391] and has been deployed succesfully in multiple MPLS networks.
With the emergence of MPLS Network Actions [I-D.ietf-mpls-mna-requirements] [I-D.ietf-mpls-mna-fwk] [I-D.ietf-mpls-mna-hdr], there is a benefit to being able to describe entropy as a network action. Without this, a packet that required load balancing and network actions would need to deal with the overhead of having both MNA and an Entropy Label in the label stack. By defining an action for Entropy within the MNA infrastructure, overhead and complexity can be reduced. It is RECOMMENDED that MNA and the Entropy Label not be used in the same packet, but if they are, the Entropy Label and Entropy Value do not need to be the same as consistency for the flow suffices.
Given that [RFC6790] is widely deployed, it is expected that that will continue to be a common mechanism for encoding an Entropy Label. This document adds an alternative encoding that may be more efficient if other MNA actions are in use. The two encodings can co-exist in the same network.
Requirement Language
The key words "MUST", "MUST NOT", "REQUIRED", "SHALL", "SHALL NOT", "SHOULD", "SHOULD NOT", "RECOMMENDED", "NOT RECOMMENDED", "MAY", and "OPTIONAL" in this document are to be interpreted as described in BCP 14 [RFC2119] [RFC8174] when, and only when, they appear in all capitals, as shown here. These words may also appear in this document in lower case as plain English words, absent their normative meanings.
The Entropy Action
This section describes the details of how the Entropy Action is encoded, per Section 5 of [I-D.ietf-mpls-mna-fwk].
- Name: Entropy Action
- Network Action Indication: The Entropy Action is opcode TBA1.
- Scope: The Entropy Action is valid in Hop-by-Hop (HBH) and Select scopes and SHOULD be processed as discussed below. The Entropy Action is not valid in I2E scope and SHOULD be ignored if found in I2E scope.
- In-Stack Data: The Entropy Action carries 20 bits of ancillary data, known as the Entropy Value.
- Processing: The semantics of the Entropy Value are identical to the semantics of the Entropy Label as found in [RFC6790], [RFC8012], and [RFC8662], except that the Entropy Value is not found in the Label field of the Label Stack Entry (LSE). While the RFC 6790 Entropy Label has some restrictions to avoid collisions with the reserved label space (0-15) [RFC3032], those restrictions are not necessary for the Entropy Value and do not apply. A forwarding node SHOULD incorporate the Entropy Value into its forwarding decision when the Entropy Action is evaluated. Not using the Entropy Value may result in unintended forwarding consequences, possibly resulting in unnecessary congestion and packet loss.
- LSE Format: C. There is no additional data. The Network Action Length (NAL) field MUST be sent as zero. The U bit in the Format C LSE may be set at the discretion of the implementation and network operator. If there are no further actions to be included in the Network Action Sub-Stack (NAS), then the Entropy Action must follow an opcode 2 (NOP) Format B LSE.
- Interactions: None
Security Considerations
The forwarding plane is insecure. If an adversary can affect the forwarding plane, then they can inject data, remove data, corrupt data, or modify data. MNA additionally allows an adversary to make packets perform arbitrary network actions.
Link-level security mechanisms can help mitigate some on-link attacks, but does nothing to preclude hostile nodes.
IANA Considerations
This document requests that IANA allocate a codepoint (TBA1) from the "Multiprotocol Label Switching Architecture (MPLS)"/"MPLS Network Actions Parameters"/"Network Action Opcodes Registry" registry for the Entropy Action. The allocation should reference this document.

Normative References

Informative References
[RFC6790]
[RFC6391]
[I-D.ietf-mpls-mna-requirements]
[I-D.ietf-mpls-mna-fwk]
[I-D.ietf-mpls-mna-hdr]
[RFC2119]
[RFC8174]
[RFC8012]
[RFC8662]
[RFC3032]